import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;
import java.awt.Polygon;
import java.awt.Color;
/**
 * Write a description of class RandomImageCreator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PolygonImage extends Actor
{
    private List<MovingPoint> list_mp_=new ArrayList();
    private double d_R=Math.random()*90000,d_G=Math.random()*90000,d_B=Math.random()*90000;

    public PolygonImage(int width, int height)
    {
        setImage(new GreenfootImage(width,height));
        initPoints(width*height/5000);
        updateImage();
    }

    public void act()
    {
        movePoints();
        updateImage();
    }

    private void movePoints()
    {
        for(MovingPoint mp_:list_mp_)
            mp_.move();
    }

    public void updateImage()
    {
        getImage().clear();
        getImage().setColor(
        new Color(
        (int)((Math.sin((d_R+=Math.random())*0.01)+1)*127.5),
        (int)((Math.sin((d_G+=Math.random())*0.01)+1)*127.5),
        (int)((Math.sin((d_B+=Math.random())*0.01)+1)*127.5)));
        Polygon poly_=new Polygon();
        for(MovingPoint mp_:list_mp_)
            poly_.addPoint((int)mp_.d_X,(int)mp_.d_Y);
        getImage().fillShape(poly_);
    }

    public void initPoints(int i_HowMany)
    {
        list_mp_.clear();
        int
        i_Width=getImage().getWidth(),
        i_Height=getImage().getHeight();
        for(int i=0;i<i_HowMany;i++)
            list_mp_.add(new MovingPoint((int)(Math.random()*i_Width),(int)(Math.random()*i_Height),i_Width,i_Height));
    }

    private class MovingPoint
    {
        private double d_SpeedX=Math.random()*3-1,d_SpeedY=Math.random()*3-1.5,d_X,d_Y;
        private int i_MaxX,i_MaxY;

        public MovingPoint(int i_X,int i_Y,int i_MaxX,int i_MaxY)
        {
            this.i_MaxX=i_MaxX;
            this.i_MaxY=i_MaxY;
            this.d_X=i_X;
            this.d_Y=i_Y;
        }

        public void move()
        {
            d_X+=d_SpeedX;
            d_Y+=d_SpeedY;
            if(d_X>=i_MaxX)
                d_SpeedX=-Math.abs(d_SpeedX);
            if(d_Y>=i_MaxY)
                d_SpeedY=-Math.abs(d_SpeedY);
            if(d_Y<=0)
                d_SpeedY=Math.abs(d_SpeedY);
            if(d_X<=0)
                d_SpeedX=Math.abs(d_SpeedX);
        }
    }
}